#!/bin/bash
# archiveweblogs.sh v1.0

# Troy Engel &lt;tengel@fluid.com&gt;
#   ,   .
#    .
#
#       
#+       RedHat/Apache.
#        -,
#+  (bzip),       .
#
#    crontab   0 ,
#+   bzip2     , 
#+    :
#  0 2 * * * /opt/sbin/archiveweblogs.sh


PROBLEM=66

#      .
BKP_DIR=/opt/backups/weblogs

#  Apache/RedHat -
LOG_DAYS="4 3 2 1"
LOG_DIR=/var/log/httpd
LOG_FILES="access_log error_log"

#    RedHat -
LS=/bin/ls
MV=/bin/mv
ID=/usr/bin/id
CUT=/bin/cut
COL=/usr/bin/column
BZ2=/usr/bin/bzip2

#   ?
USER=`$ID -u`
if [ "X$USER" != "X0" ]; then
  echo "PANIC:  root    !"
  exit $PROBLEM
fi

#         ?
if [ ! -x $BKP_DIR ]; then
  echo "PANIC:  $BKP_DIR       !"
  exit $PROBLEM
fi

# ,   
for logday in $LOG_DAYS; do
  for logfile in $LOG_FILES; do
    MYFILE="$LOG_DIR/$logfile.$logday"
    if [ -w $MYFILE ]; then
      DTS=`$LS -lgo --time-style=+%Y%m%d $MYFILE | $COL -t | $CUT -d ' ' -f7`
      $MV $MYFILE $BKP_DIR/$logfile.$DTS
      $BZ2 $BKP_DIR/$logfile.$DTS
    else
      #    ,     .
      if [ -f $MYFILE ]; then
        echo "ERROR: $MYFILE not writable. Skipping."
      fi
    fi
  done
done

exit 0
