#! /bin/bash
# array-append.bash

# Copyright (c) Michael S. Zick, 2003, All rights reserved.
#  :   
#       .
# : $ID$
#
#   ,   .


#       Bash.
#   /bin/sh !


#         ,
#+    ,  ,  'more'.


#  .
declare -a array1=( zero1 one1 two1 )
#   ( [1] --  ).
declare -a array2=( [0]=zero2 [2]=two2 [3]=three2 )

echo
echo '-  ,    . -'
echo " : 4"        #  "",   .
for (( i = 0 ; i < 4 ; i++ ))
do
    echo " [$i]: ${array2[$i]}"
done
# .    basics-reviewed.bash.


declare -a dest

#   .
echo
echo ':  , IFS -, -'
echo '-    . -'
# #        .

dest=( ${array1[@]} ${array2[@]} )
# dest=${array1[@]}${array2[@]}     #  ,  .

#   .
echo
echo '- -    - -'
cnt=${#dest[@]}

echo " : $cnt"
for (( i = 0 ; i < cnt ; i++ ))
do
    echo " [$i]: ${dest[$i]}"
done

#       ().
dest[0]=${array1[@]}
dest[1]=${array2[@]}

#  .
echo
echo '- -          - -'
cnt=${#dest[@]}

echo " : $cnt"
for (( i = 0 ; i < cnt ; i++ ))
do
    echo " [$i]: ${dest[$i]}"
done

#    .
echo
echo '- -        - -'

declare -a subArray=${dest[1]}
cnt=${#subArray[@]}

echo " : $cnt"
for (( i = 0 ; i < cnt ; i++ ))
do
    echo " [$i]: ${subArray[$i]}"
done

#         ,
#+    '=${ ... }',
#+        ,
#+        
#+ (    IFS).

# If the original elements didn't contain whitespace . . .
# If the original array isn't subscript sparse . . .
# Then we could get the original array structure back again.

# Restore from the modified second element.
echo
echo '- - Listing restored element - -'

declare -a subArray=( ${dest[1]} )
cnt=${#subArray[@]}

echo "Number of elements: $cnt"
for (( i = 0 ; i < cnt ; i++ ))
do
    echo "Element [$i]: ${subArray[$i]}"
done
echo '- - Do not depend on this behavior. - -'
echo '- - This behavior is subject to change - -'
echo '- - in versions of Bash newer than version 2.05b - -'

# MSZ: Sorry about any earlier confusion folks.

exit 0
