#!/bin/bash
# array-strops.sh:    .
# : Michael Zick.
#    .

#   ,  ,   ${name ... }
#+        
#+  : ${name[@] ... }  ${name[*] ...} .


arrayZ=( one two three four five five )

echo

#   
echo ${arrayZ[@]:0}     # one two three four five five
                        #   .

echo ${arrayZ[@]:1}     # two three four five five
                        #   ,   2-.

echo ${arrayZ[@]:1:2}   # two three
                        #   ,   2-.

echo "-----------------------"

#    
#     ,    (    )
#+   --   .

echo ${arrayZ[@]#f*r}   # one two three five five
                        #   "four"   .
                        #      

#   ,    
echo ${arrayZ[@]##t*e}  # one two four five five
                        #   "three"   .
                        #      

#     ,    (    )
echo ${arrayZ[@]%h*e}   # one two t four five five
                        #   "hree"   .
                        #      

#    ,    (    )
echo ${arrayZ[@]%%t*e}  # one two four five five
                        #   "three"   .
                        #      

echo "-----------------------"

#   

#      
echo ${arrayZ[@]/fiv/XYZ}   # one two three four XYZe XYZe
                            #      

#    
echo ${arrayZ[@]//iv/YY}    # one two three four fYYe fYYe
                            #      

#    
#     ,    ""
echo ${arrayZ[@]//fi/}      # one two three four ve ve
                            #      

#     (    )
echo ${arrayZ[@]/#fi/XY}    # one two three four XYve XYve
                            #      

#     (    )
echo ${arrayZ[@]/%ve/ZZ}    # one two three four fiZZ fiZZ
                            #      

echo ${arrayZ[@]/%o/XX}     # one twXX three four five five
                            # ?

echo "-----------------------"


# Before reaching for awk (or anything else)
# :
#   $( ... ) --  .
#      .
#      stdout.
#      stdout .
#    name[@] --   "for-each".

newstr() {
    echo -n "!!!"
}

echo ${arrayZ[@]/%e/$(newstr)}
# on!!! two thre!!! four fiv!!! fiv!!!
# Q.E.D:  --   "".

#   "For-Each" --    
echo ${arrayZ[@]//*/$(newstr optional_arguments)}
#  Now, if Bash would just pass the matched string as $0
#+ to the function being called . . .

echo

exit 0
