#!/bin/bash
# basics-reviewed.bash

#   == *.bash == ,   Bash

#   Copyright (c) Michael S. Zick, 2003; All rights reserved.
#   License: Use in any form, for any purpose.
#   : $ID$
#
#              ,    ,   .
#   ("Advanced Bash Scripting Guide")


#      Bash  2.04, 2.05a  2.05b.
#         .
#      
#+ "command not found". .  394.

#    Bash, Chet Ramey,    
#+    Bash.


        ###-------------------------------------------###
        ###           ###
        ###+ ,     ###
        ###+   more                          ###
        ###                                           ###
        ###   ,         ###
        ###+   ,          ###  
        ###+                                  ###  
        ###-------------------------------------------###


#         
#+    "Advanced Bash Scripting Guide."
#   ,        .
#      -- msz

#   ,    .

#     . 
#         .
#     ( : 2>&1)
#+   ¾̺ .

#     Bash -- .
# (,   ,    .)

#   Bash    .
unset VarNull

#   Bash   ,   "" (null) .
VarEmpty=''

#       ,  
VarSomething='Literal'

#   :
#   *  32-   
#   *  
#    .

#       
#+     .

#      
#+      (namespaces).


#        ,   
#+      .
#  :
declare -a ArrayVar


#  echo --  .
echo $VarSomething

#  printf --  .
#  %s    
printf %s $VarSomething         #   ,   .
echo                            #    .




#  Bash        .
#      --   .
# (    ,      .)




#  "" ($)  : Content-Of (  ...).

#  ,    "":
echo ${VarSomething}

#  ,   ${ ... },   
#+    .
#   ,  $VarSomething 
#+       : ${VarSomething}.

#       --   
#+    .


#     ,   @  *
#+   .
#    : All-Elements-Of (--).

#      ,    
#+     Bash.


echo $*                         #      
echo ${*}                       #   


# Bash       .



#   --
echo $@                         #   ,   
echo ${@}                       #   




#    ,   @  * 
#+     IFS (Input Field Separator --  ).
#    --,   ,    .


#       
#+   () .


#       () ,
#+     (. ).




#     -  Bash 
#+      ,
#+         Ƹ .

#       ,    ,
#+  ,     .
#    : ${name[subscript]}.

#        : ${name:subscript},
#+        .


#   Bash    ,
#+      ,     
#+  .

#      Bash:
#   -------------------------------

#      ,    Bash 
#+    : [0]
#     "  ".
###
#      ,   Bash  
#+  (..        ).
###
#     .
###
#             .
###
#       .
#       ..    ""
###
#         .
###
#      :
#     *  32-   
#     * 
#     *  ,   
#     +      
###
#          (unset).
#       ..     ,
#   +           .
###
#        ,
#+    .
###
#       Bash -- "Bash-" ("Bash-Arrays").
# 
#     -- msz




#    --     ArrayVar 
#+  "" .
#  ( 'unset ... '    .)

unset ArrayVar[0]                   #  
ArrayVar[1]=one                     #  
ArrayVar[2]=''                      #   
unset ArrayVar[3]                   #  
ArrayVar[4]='four'                  #  



#   %q --  : Quoted-Respecting-IFS-Rules 
#+ (    IFS).
echo
echo '- -    - -'
###
printf %q ${ArrayVar[*]}            #  "--"
echo
echo ' echo:'${ArrayVar[*]}
###
printf %q ${ArrayVar[@]}            # "--"
echo
echo ' echo:'${ArrayVar[@]}

#       
#+  .
#     , 
#+      IFS.

echo
echo '- -    - - IFS  -- - -'
IFS=$'\x20'$'\x09'$'\x0A'           #   ,
                                    #+     .

printf %q "${ArrayVar[*]}"          #  "--"
echo
echo ' echo:'"${ArrayVar[*]}"
###
printf %q "${ArrayVar[@]}"          # "--"
echo
echo ' echo:'"${ArrayVar[@]}"

echo
echo '- -    -    IFS: ^ - -'
#  ,  ,    .
IFS='^'$IFS                         # ^ +    
###
printf %q "${ArrayVar[*]}"          #  "--"
echo
echo ' echo:'"${ArrayVar[*]}"
###
printf %q "${ArrayVar[@]}"          # "--"
echo
echo ' echo:'"${ArrayVar[@]}"


echo
echo '- -    - IFS    - -'
IFS='^:%!'
###
printf %q "${ArrayVar[*]}"          #  "--"
echo
echo ' echo:'"${ArrayVar[*]}"
###
printf %q "${ArrayVar[@]}"          # "--"
echo
echo ' echo:'"${ArrayVar[@]}"


echo
echo '- -    -  IFS  - -'
IFS=''
###
printf %q "${ArrayVar[*]}"          #  "--"
echo
echo ' echo:'"${ArrayVar[*]}"
###
printf %q "${ArrayVar[@]}"          # "--"
echo
echo ' echo:'"${ArrayVar[@]}"


echo
echo '- -    -  IFS   - -'
unset IFS
###
printf %q "${ArrayVar[*]}"          #  "--" All-Elements-Of
echo
echo ' echo:'"${ArrayVar[*]}"
###
printf %q "${ArrayVar[@]}"          # "--"
echo
echo ' echo:'"${ArrayVar[@]}"


#   IFS   ,
#     -.
IFS=$'\x20'$'\x09'$'\x0A'           #    .

#  ,  :
#       "--"     IFS.
###
#     "--"      IFS.
###
#      ,    
#+    echo  printf   %q.




#   :
#           .
###
#    ,   ,   
#+   ,    .
###




#       ():
echo
echo '- -      - -'
echo '  : '${#VarSomething}'.'


# test='Lit'$'\x00''eral'           # $'\x00' --  (null) .
# echo ${#test}                     #  ?



#       ,
#+  ,   .
echo
echo '    : '${#ArrayVar[@]}'.'
#      (4).
#     (1 . . 4 ).
#    .
###
#        
#+   ,      .


#       ():
echo
echo '- -      - -'
echo '  : '"${#VarSomething}"'.'

#       ,
#+  ,   .
echo
echo '    : '"${#ArrayVar[*]}"'.'

#  :  ${# ... }   .
#  :
#     All-Elements-Of (--)
#+    ,      IFS.



#    .
#        
#+  - ,   ,   .
###
#  Bash     ,
#+      .
###

_simple() {
    echo -n 'SimpleFunc'$@          #       
}                                   #+  "".


#  ( ... )    .
#   $( ... )  : Result-Of (-).


#   _simple
echo
echo '- -    _simple - -'
_simple                             #    .
echo
# 
(_simple)                           #    .
echo

echo '-      ? -'
echo $_simple not defined           #     .

#      _simple 
# (    )
###
$(_simple)                          #    :
#                          line 394: SimpleFunc: command not found
#                          ---------------------------------------

echo
###

#     :    _simple  
#+   Bash,     .
###
#   ,     _simple 
#+  .
###
# :
#         Bash.


#  ,    bash:
###
_print() {
    echo -n 'printf %q '$@
}

echo '- -    _print - -'
_print parm1 parm2                  #   --  .
echo

$(_print parm1 parm2)               #    printf %q parm1 parm2
                                    #  .   IFS 
                                    #+    .
echo

$(_print $VarSomething)             #   .
echo



# -
# ------------------

echo
echo '- - - - -'
#     ,   .
#      .

# set -vx                           #    
declare -f funcVar                  #    !

funcVar=_print                      #   .
$funcVar parm1                      #    _print.
echo

funcVar=$(_print )                  #   .
$funcVar                            #   ,  .
$funcVar $VarSomething              #  .
echo

funcVar=$(_print $VarSomething)     #     
                                    #+   $VarSomething.
$funcVar                            #    $VarSomething
echo                                #+    $funcVar


funcVar="$(_print $VarSomething)"   #     
                                    #+   $VarSomething.
$funcVar                            #    $VarSomething
echo                                #+    $funcVar

#        
#+    "protect_literal.sh".
#     Bash      ,
#    --         .




#  
# ----------------------

echo
echo '- -   - -'
funcVar="$(_print '$VarSomething')" #     .
eval $funcVar                       #   .
echo

VarSomething='NewThing'
eval $funcVar                       #   .
echo

#     VarSomething.
VarSomething=Literal

#    "protect_literal.sh"  "unprotect_literal.sh" 
#+    ,    
#+  .





# :
# -----

#        -.
#        () 
###
#  : ${array_name[@]}    
#+ Bash-: array_name.
###
#   ,   ,  
#+    .
###
#        For-Each   .
###
#    .
#           
#+ ${0},    .
###
#        
###
#        .
#        $FUNCNAME.
###

echo
echo '- -  (   ) - -'
echo '-   -'
echo -n ${VarNull-'NotSet'}' '          # NotSet
echo ${VarNull}                         #   
echo -n ${VarNull:-'NotSet'}' '         # NotSet
echo ${VarNull}                         #   

echo '- ""  -'
echo -n ${VarEmpty-'Empty'}' '          #  
echo ${VarEmpty}                        #   
echo -n ${VarEmpty:-'Empty'}' '         # Empty
echo ${VarEmpty}                        #   

echo '-   -'
echo ${VarSomething-'Content'}          # Literal
echo ${VarSomething:-'Content'}         # Literal

echo '-   -'
echo ${ArrayVar[@]-'not set'}

# ASCII-Art time
# State     Y==yes, N==no
#           -       :-
# Unset     Y       Y       ${# ... } == 0
# Empty     N       Y       ${# ... } == 0
# Contents  N       N       ${# ... } > 0

#   ,       -
#+      .
echo
echo '- -  1,    - -'
declare -i t
_decT() {
    t=$t-1
}

#    : t == -1
t=${#VarNull}                           # t == 0
${VarNull- _decT }                      #  ,  t == -1.
echo $t

# "" : t == 0
t=${#VarEmpty}                          # t == 0
${VarEmpty- _decT }                     #  _decT  .
echo $t

#  : t ==   
VarSomething='_simple'                  #     .
t=${#VarSomething}                      #  
${VarSomething- _decT }                 #   _simple.
echo $t                                 #    .

# :    .
unset t
unset _decT
VarSomething=Literal

echo
echo '- -  (   ) - -'
echo '- ,     -'
echo -n ${VarNull='NotSet'}' '          # NotSet NotSet
echo ${VarNull}
unset VarNull

echo '- ,     -'
echo -n ${VarNull:='NotSet'}' '         # NotSet NotSet
echo ${VarNull}
unset VarNull

echo '-  ,    -'
echo -n ${VarEmpty='Empty'}' '          #  
echo ${VarEmpty}
VarEmpty=''

echo '- ,    -'
echo -n ${VarEmpty:='Empty'}' '         # Empty Empty
echo ${VarEmpty}
VarEmpty=''

echo '-  ,     -'
echo ${VarSomething='Content'}          # Literal
echo ${VarSomething:='Content'}         # Literal


# "" Bash-
###
#  Bash-    ,   ,
#+    ,   .
###
#    ArraySparse    ,
#+  " ".      :
###
echo
declare -a ArraySparse
ArraySparse=( [1]=one [2]='' [4]='four' )
# [0]= , [2]= , [3]= 

echo '- -   - -'
#   ,  IFS -- -, --

IFS=$'\x20'$'\x09'$'\x0A'
printf %q "${ArraySparse[*]}"
echo

#        ,    
#+    .
#      .
###
#       ,     ,
#+    ,  
###
#    "" Bash,  2.04, 2.05a  2.05b, 
#+    has been reported
#+        Bash.

#         
#+    .
#         :
###
# local l=${#ArraySparse[@]}        #   
# local f=0                         #   
# local i=0                         #  
(                                   #  
    for (( l=${#ArraySparse[@]}, f = 0, i = 0 ; f < l ; i++ ))
    do
        # 'if defined then...'
        ${ArraySparse[$i]+ eval echo '\ ['$i']='${ArraySparse[$i]} ; (( f++ )) }
    done
)

#  :
#   "read -a array_name"   
#+ array_name   .
#  ArraySparse --    .
###
#       , 
#+   /  / 
#+      , 
#+    .
###
# :     .

unset ArraySparse

echo
echo '- -    (  )- -'
echo '-       -'
echo -n ${VarNull+'NotSet'}' '
echo ${VarNull}
unset VarNull

echo '-       -'
echo -n ${VarNull:+'NotSet'}' '
echo ${VarNull}
unset VarNull

echo '-     -'
echo -n ${VarEmpty+'Empty'}' '              # Empty
echo ${VarEmpty}
VarEmpty=''

echo '-      -'
echo -n ${VarEmpty:+'Empty'}' '             #  
echo ${VarEmpty}
VarEmpty=''

echo '- ,     -'

echo -n ${VarSomething+'Content'}' '        # Content Literal
echo ${VarSomething}

#  
echo -n ${VarSomething:+ $(_simple) }' '    # SimpleFunc Literal
echo ${VarSomething}
echo

echo '- -   - -'
echo ${ArrayVar[@]+'Empty'}                 # An array of 'Empty'(ies)
echo

echo '- -  2,   - -'

declare -i t
_incT() {
    t=$t+1
}

#   :
#     ,       

#  : t == -1
t=${#VarNull}-1                     # t == -1
${VarNull+ _incT }                  #   .
echo $t'   '

#  : t == 0
t=${#VarEmpty}-1                    # t == -1
${VarEmpty+ _incT }                 #  .
echo $t'   '

#   : t == (  )
t=${#VarSomething}-1                # __  
${VarSomething+ _incT }             #  .
echo $t'    '


#    
# -------------------------------

echo
echo '- -   - -'

#  ,    

#        ,
#+     

echo '-  -'
echo ${VarSomething:0}              #    
echo ${ArrayVar[@]:0}               #    
echo ${@:0}                         #    ;
                                    #  [0] 

echo
echo '-   -'
echo ${VarSomething:1}              #    ,   [0]
echo ${ArrayVar[@]:1}               #    ,   [0]
echo ${@:2}                         #    ,   [1]

echo
echo '-   -'
echo ${VarSomething:4:3}            # ral
                                    #  , 
                                    #   [3]

echo '-   -'
echo ${ArrayVar[@]:1:2}     #  four -   .


#     ,  Bash      
#+  
#  printf %q "${ArrayVar[@]:0:3}"    #    

#   Bash 2.04, 2.05a  2.05b,
#+        .
#
#  Chet Ramey       Bash.


echo '-   -'
echo ${@:2:2}               #   [1]    

#       :
stringZ=abcABC123ABCabc
arrayZ=( abcabc ABCABC 123123 ABCABC abcabc )
sparseZ=( [1]='abcabc' [3]='ABCABC' [4]='' [5]='123123' )

echo
echo ' - -   - -'$stringZ'- - '
echo ' - -   - -'${arrayZ[@]}'- - '
echo ' - -   - -'${sparseZ[@]}'- - '
echo ' - [0]== , [2]== , [4]==  - '
echo ' - [1]=abcabc [3]=ABCABC [5]=123123 - '
echo ' -   : '${#sparseZ[@]}

echo
echo '- -  - -'
echo '- -       . - -'
echo '- -        . - -'
echo


# ,      
_abc() {
    echo -n 'abc'
}

echo '-   -'
echo ${stringZ#123}                 #   --  .
echo ${stringZ#$(_abc)}             # ABC123ABCabc
echo ${arrayZ[@]#abc}               #     .

# Chet Ramey      Bash.
# echo ${sparseZ[@]#abc}            #   2.05b -- core dumps.

# -   - First-Subscript-Of (--)
# echo ${#sparseZ[@]#*}             #  line 805: ${#sparseZ[@]#*}: bad substitution.

echo
echo '-   -'
echo ${stringZ##1*3}                #   --  .
echo ${stringZ##a*C}                # abc
echo ${arrayZ[@]##a*c}              # ABCABC 123123 ABCABC

# Chet Ramey      Bash.
# echo ${sparseZ[@]##a*c}           #   2.05b -- core dumps.

echo
echo '- -  - -'
echo '- -       . - -'
echo '- -        . - -'
echo
echo '-   -'
echo ${stringZ%1*3}                 #   --  .
echo ${stringZ%$(_abc)}             # abcABC123ABC
echo ${arrayZ[@]%abc}               #     .

# Chet Ramey      Bash.
# echo ${sparseZ[@]%abc}            #   2.05b -- core dumps.

# -   - Last-Subscript-Of (--)
# echo ${#sparseZ[@]%*}             #  line 830: ${#sparseZ[@]%*}: bad substitution

echo
echo '-   -'
echo ${stringZ%%1*3}                #   --  .
echo ${stringZ%%b*c}                # a
echo ${arrayZ[@]%%b*c}              # a ABCABC 123123 ABCABC a

# Chet Ramey      Bash.
# echo ${sparseZ[@]%%b*c}           #   2.05b -- core dumps.

echo
echo '- -   - -'
echo '- -        . - -'
echo '- -      - -'
echo '- -        . - -'
echo '- -         . - -'
echo '- -     .   :'
echo '    - () - -'
echo



# ,      
_123() {
    echo -n '123'
}

echo '-    -'
echo ${stringZ/$(_123)/999}         #  123   999).
echo ${stringZ/ABC/xyz}             # xyzABC123ABCabc
echo ${arrayZ[@]/ABC/xyz}           #     .
echo ${sparseZ[@]/ABC/xyz}          #     .

echo
echo '-    -'
echo ${stringZ/$(_123)/}
echo ${stringZ/ABC/}
echo ${arrayZ[@]/ABC/}
echo ${sparseZ[@]/ABC/}

#       ,
#+    .
#       .
echo
echo '-       -'
echo ${stringZ/$(_123)/$(_simple)}  #     .
echo ${arrayZ[@]/ca/$(_simple)}     #     .
echo ${sparseZ[@]/ca/$(_simple)}    #     .

echo
echo '-    -'
echo ${stringZ//[b2]/X}             #   b  2   X
echo ${stringZ//abc/xyz}            # xyzABC123ABCxyz
echo ${arrayZ[@]//abc/xyz}          #     .
echo ${sparseZ[@]//abc/xyz}         #     .

echo
echo '-    -'
echo ${stringZ//[b2]/}
echo ${stringZ//abc/}
echo ${arrayZ[@]//abc/}
echo ${sparseZ[@]//abc/}

echo
echo '- -   - -'
echo '- -       . - -'
echo

echo '- -   - -'
echo ${stringZ/#[b2]/X}             #   --  .
echo ${stringZ/#$(_abc)/XYZ}        # XYZABC123ABCabc
echo ${arrayZ[@]/#abc/XYZ}          #     .
echo ${sparseZ[@]/#abc/XYZ}         #     .

echo
echo '-   -'
echo ${stringZ/#[b2]/}
echo ${stringZ/#$(_abc)/}
echo ${arrayZ[@]/#abc/}
echo ${sparseZ[@]/#abc/}

echo
echo '- -   - -'
echo '- -       . - -'
echo

echo '- -   - -'
echo ${stringZ/%[b2]/X}             #   --  .
echo ${stringZ/%$(_abc)/XYZ}        # abcABC123ABCXYZ
echo ${arrayZ[@]/%abc/XYZ}          #     .
echo ${sparseZ[@]/%abc/XYZ}         #     .

echo
echo '-   -'
echo ${stringZ/%[b2]/}
echo ${stringZ/%$(_abc)/}
echo ${arrayZ[@]/%abc/}
echo ${sparseZ[@]/%abc/}

echo
echo '- -   --    - -'
echo

echo '-  -'
#        
echo ${stringZ/#/NEW}               # NEWabcABC123ABCabc
echo ${arrayZ[@]/#/NEW}             #     .
echo ${sparseZ[@]/#/NEW}            #     


echo
echo '-  -'
#        
echo ${stringZ/%/NEW}               # abcABC123ABCabcNEW
echo ${arrayZ[@]/%/NEW}             #     .
echo ${sparseZ[@]/%/NEW}            #     


echo
echo '- -    For-Each - -'
echo '- - - - This is a nice-to-have dream - - - -'
echo

_GenFunc() {
    echo -n ${0}                    #   .
    #       .
}

#  ,    "*"
#   ,  //*/     
#+   .
#      /#/  /%/       
#+   .
echo ${sparseZ[@]//*/$(_GenFunc)}


exit 0
