#!/bin/bash

ARGS=2  #     .
E_BADARGS=65
E_UNREADABLE=66

if [ $# -ne "$ARGS" ]
then
  echo " : `basename $0` file1 file2"
  exit $E_BADARGS
fi

if [[ ! -r "$1" || ! -r "$2" ]]
then
  echo "         ."
  exit $E_UNREADABLE
fi

cmp $1 $2 &> /dev/null  # /dev/null -- ""    "cmp".
#   cmp -s $1 $2      ("-s" --  ""  "cmp")
#    Anders Gustavsson  .
#
#    'diff', ..,   diff $1 $2 &> /dev/null

if [ $? -eq 0 ]         #     "cmp".
then
  echo " \"$1\"   \"$2\"."
else
  echo " \"$1\"    \"$2\"."
fi

exit 0
