#! /bin/bash
#
#  
# Bash script
# Copyright (C) 2000 Amit Singh. All Rights Reserved.
# http://hanoi.kernelthread.com
#
#   bash 2.05b.0(13)-release
#
#    "Advanced Bash Scripting Guide"
#+   .
#    ,   .

#=================================================================#
#    --    .
#     .
#      .
#          -,
#+        .
#     ,      
#+     .
#     ,  -- .
#
#      ,     
#+    ,      .
#             .
#          .
#         .
#
#         .
#+   
#+        ,
#+   ""      .
#
#       http://hanoi.kernelthread.com.
#
#
#         ...                   ...                    ...
#         | |                   | |                    | |
#        _|_|_                  | |                    | |
#       |_____|                 | |                    | |
#      |_______|                | |                    | |
#     |_________|               | |                    | |
#    |___________|              | |                    | |
#   |             |             | |                    | |
# .--------------------------------------------------------------.
# |**************************************************************|
#          #1                   #2                      #3
#
#=================================================================#


E_NOPARAM=66  #    .
E_BADPARAM=67 #   .
Moves=        #  ,   .
              #    .

dohanoi() {   #  .
    case $1 in
    0)
        ;;
    *)
        dohanoi "$(($1-1))" $2 $4 $3
        echo move $2 "-->" $3
	      let "Moves += 1"  #    .
        dohanoi "$(($1-1))" $4 $3 $2
        ;;
    esac
}

case $# in
1)
    case $(($1>0)) in     #        .
    1)
        dohanoi $1 1 3 2
        echo "  = $Moves"
        exit 0;
        ;;
    *)
        echo "$0:   ";
        exit $E_BADPARAM;
        ;;
    esac
    ;;
*)
    echo " : $0 N"
    echo "        \"N\" --   ."
    exit $E_NOPARAM;
    ;;
esac

# :
# ---------
# 1)     ,      ?
#     ? (  !)
# 2)  --    "dohanoi".
#    (    )
