#! /bin/sh
# letter-count.sh: Counting letter occurrences in a text file.
#
# : nyal (nyal@voila.fr).
#     .
#    .


INIT_TAB_AWK=""

count_case=0
FILE_PARSE=$1

E_PARAMERR=65

usage()
{
    echo " : letter-count.sh _ " 2>&1
    # :   ./letter-count.sh filename.txt a b c
    exit $E_PARAMERR  #    .
}

if [ ! -f "$1" ] ; then
    echo " $1  ." 2>&1
    usage                 #    .
fi 

if [ -z "$2" ] ; then
    echo "$2:     ." 2>&1
    usage
fi 

shift                      #  .
for letter in `echo $@`    #     . . .
  do
  INIT_TAB_AWK="$INIT_TAB_AWK tab_search[${count_case}] = \"$letter\"; final_tab[${count_case}] = 0; " 
  #      awk .
  count_case=`expr $count_case + 1`
done

# DEBUG:
# echo $INIT_TAB_AWK;

cat $FILE_PARSE |
#        awk.

# --------------------------------------------------------------------------------
#  :
#          :
#awk -v tab_search=0 -v final_tab=0 -v tab=0 -v nb_letter=0 -v chara=0 -v chara2=0 \
# 
#      gawk 3.1.3   
#             ,
#        :
awk -v nb_letter=0 -v chara=0 -v chara2=0 \
"BEGIN { $INIT_TAB_AWK } \
{ split(\$0, tab, \"\"); \
for (chara in tab) \
{ for (chara2 in tab_search) \
{ if (tab_search[chara2] == tab[chara]) { final_tab[chara2]++ } } } } \
END { for (chara in final_tab) \
{ print tab_search[chara] \" => \" final_tab[chara] } }"
# --------------------------------------------------------------------------------
#   . . .
#+  for,   if,    .

exit $?
