#! /bin/bash
# protect_literal.sh

# set -vx

:<<-'_Protect_Literal_String_Doc'

    Copyright (c) Michael S. Zick, 2003; All Rights Reserved
    :         .
    : 
    : $ID$

       Bash    '/dev/null'.
    (  set,  ,    .)

       (Sha-Bang),      
      .       
      (   ).


     :
        _protect_literal_str 'Whatever string meets your ${fancy}'
              ,
             stdout,
         "" .

        $(_protect_literal_str 'Whatever string meets your ${fancy}')
            .

    :
          ,  
          ,   ""
        .

    :
          (_*)   ,  
         ,    
          ,   .

_Protect_Literal_String_Doc

_protect_literal_str() {

#  ,        IFS.
#    ,     
# ,    .
    local IFS=$'\x1B'               #  \ESC

#  -  "" .
    local tmp=$'\x27'$@$'\x27'

    local len=${#tmp}       #   .
    echo $tmp, :$len.  #     .
}

#     .
_pls() {
    local IFS=$'x1B'                #  \ESC ( )
    echo $'\x27'$@$'\x27'           #   "" 
}

# :<<-'_Protect_Literal_String_Test'
# # #   ,     . # # #

#     .
echo
echo "- -  #1 - -"
_protect_literal_str 'Hello $user'
_protect_literal_str 'Hello "${username}"'
echo

#    :
# - -  #1 - -
# 'Hello $user', : 13.
# 'Hello "${username}"', : 21.

#    ,   ,    ?
#     Bash,    .
#   ,      .

#    .
declare -a arrayZ

#           .
arrayZ=( zero "$(_pls 'Hello ${Me}')" 'Hello ${You}' "\'Pass: ${pw}\'" )

#       ,   .
echo "- -  #2 - -"
for (( i=0 ; i<${#arrayZ[*]} ; i++ ))
do
    echo   $i: ${arrayZ[$i]}, : ${#arrayZ[$i]}.
done
echo

#    :
# - -  #2 - -
#  0: zero, : 4.           #  (  ) 
#  1: 'Hello ${Me}', : 13. #  "$(_pls '...' )"
#  2: Hello ${You}, : 12.  #  
#  3: \'Pass: \', : 10.    # ${pw} --  ,
#                                      #       

#     .
declare -a array2=( ${arrayZ[@]} )

#    .
echo "- -  #3 - -"
for (( i=0 ; i<${#array2[*]} ; i++ ))
do
    echo   $i: ${array2[$i]}, : ${#array2[$i]}.
done
echo

#    :
# - -  #3 - -
#  0: zero, : 4.           #  .
#  1: Hello ${Me}, : 11.   #   .
#  2: Hello, : 5.          # ${You} --  .
#                                      #       
#  3: 'Pass:, : 6.         #   ""    .
#  4: ', : 1.              #      .

#    1      "" .
#      ,       .
#  ,    , Bash , , 
#  ""   ,    

#    ?
#    ,   "$(_pls 'Hello ${Me}')":
#  " ... " ->   (),  .
#  $( ... ) ->    ...,  .
#  _pls ' ... ' ->     ,  .
#       "" ;   
#+    ,       
#+ .
#
#   , ${Me}   
#+     
#  (  ,         ).

#  : ,  ,    
#+ ""  ($'\x27')   "" ($'\x22').
#        .

# _Protect_Literal_String_Test
# # #   ,     . # # #

exit 0
