#!/bin/bash
# random-between.sh
#     .
# : Bill Gradwohl,
#     .
#     .


randomBetween() {
   #       ,
   #+    $min  $max,
   #+    $divisibleBy.
   #
   #  Bill Gradwohl - Oct 1, 2003

   syntax() {
   #  .
      echo
      echo    " : randomBetween [min] [max] [multiple]"
      echo
      echo    "   3-  ,     ."
      echo    "min --   "
      echo    "max --   "
      echo    "multiple -- ,       ."
      echo
      echo    "     , -  : 0 32767 1"
      echo    "     0,  -- 1"
      echo    "     ."
      echo    "     randomBetweenAnswer"
      echo    " ,   ,  ."
   }

   local min=${1:-0}
   local max=${2:-32767}
   local divisibleBy=${3:-1}
   #       ,    -.

   local x
   local spread

   #     .
   [ ${divisibleBy} -lt 0 ] && divisibleBy=$((0-divisibleBy))

   #    .
   if [ $# -gt 3 -o ${divisibleBy} -eq 0 -o  ${min} -eq ${max} ]; then
      syntax
      return 1
   fi

   #  min   max,    .
   if [ ${min} -gt ${max} ]; then
      #  .
      x=${min}
      min=${max}
      max=${x}
   fi

   #   min      $divisibleBy,
   #+          .
   if [ $((min/divisibleBy*divisibleBy)) -ne ${min} ]; then
      if [ ${min} -lt 0 ]; then
         min=$((min/divisibleBy*divisibleBy))
      else
         min=$((((min/divisibleBy)+1)*divisibleBy))
      fi
   fi

   #   max      $divisibleBy,
   #+          .
   if [ $((max/divisibleBy*divisibleBy)) -ne ${max} ]; then
      if [ ${max} -lt 0 ]; then
         max=$((((max/divisibleBy)-1)*divisibleBy))
      else
         max=$((max/divisibleBy*divisibleBy))
      fi
   fi

   #  ---------------------------------------------------------------------
   #       .

   #   :       
   #+     0 
   #+ abs(max-min)+divisibleBy,   abs(max-min)+1.

   #        
   #+        .

   #       abs(max-min)+1,
   #+      ,   ,
   #+     
   #+   .
   #  ---------------------------------------------------------------------

   spread=$((max-min))
   [ ${spread} -lt 0 ] && spread=$((0-spread))
   let spread+=divisibleBy
   randomBetweenAnswer=$(((RANDOM%spread)/divisibleBy*divisibleBy+min))

   return 0
}

#  .
min=-14
max=20
divisibleBy=3


#   ,        
#+   .

declare -a answer
minimum=${min}
maximum=${max}
   if [ $((minimum/divisibleBy*divisibleBy)) -ne ${minimum} ]; then
      if [ ${minimum} -lt 0 ]; then
         minimum=$((minimum/divisibleBy*divisibleBy))
      else
         minimum=$((((minimum/divisibleBy)+1)*divisibleBy))
      fi
   fi


   #   max      $divisibleBy,
   #+          .

   if [ $((maximum/divisibleBy*divisibleBy)) -ne ${maximum} ]; then
      if [ ${maximum} -lt 0 ]; then
         maximum=$((((maximum/divisibleBy)-1)*divisibleBy))
      else
         maximum=$((maximum/divisibleBy*divisibleBy))
      fi
   fi


#        --
#+      ,
#+     displacement, 
#+   .

displacement=$((0-minimum))
for ((i=${minimum}; i<=${maximum}; i+=divisibleBy)); do
   answer[i+displacement]=0
done


#     ,   --   .
loopIt=1000   #     100000 ,
              #+        .

for ((i=0; i<${loopIt}; ++i)); do

   #   :  min  max     ,
   #+  ,     .

   randomBetween ${max} ${min} ${divisibleBy}

   #    ,     .
   [ ${randomBetweenAnswer} -lt ${min} -o ${randomBetweenAnswer} -gt ${max} ] && echo     MIN .. MAX  - ${randomBetweenAnswer}!
   [ $((randomBetweenAnswer%${divisibleBy})) -ne 0 ] && echo         - ${randomBetweenAnswer}!

   #     .
   answer[randomBetweenAnswer+displacement]=$((answer[randomBetweenAnswer+displacement]+1))
done



#   

for ((i=${minimum}; i<=${maximum}; i+=divisibleBy)); do
   [ ${answer[i+displacement]} -eq 0 ] && echo " $i     ." || echo " ${i}  ${answer[i+displacement]} ."
done


exit 0
