#!/bin/bash
# ==> usb.sh
# ==>     USB- -.
# ==>    root     (. ).
 
#       GNU GPL license  2  .
#        http://www.gnu.org/.
#
#       usb-mount,  Michael Hamilton (LGPL)
#+ . http://users.actrix.co.nz/michael/usbmount.html
#
#  °
#  ---------
#      /etc/hotplug/usb/diskonkey.
#       usb-storage   /etc/hotplug/usb.distmap
#+  /etc/hotplug/usb.usermap,  "usb-storage"  "diskonkey".
#
#  TODO
#  ----
#      diskonkey ( /dev/diskonkey1
#+  /mnt/diskonkey1),  ..        
#+ devlabel.
#
#  ¾  
#  -------------------
#  Konstantin Riabitsev, &lt;icon linux duke edu&gt;.
#          .
#
# ==>    .



SYMLINKDEV=/dev/diskonkey
MOUNTPOINT=/mnt/diskonkey
DEVLABEL=/sbin/devlabel
DEVLABELCONFIG=/etc/sysconfig/devlabel
IAM=$0

##
#    usb-mount.
#
function allAttachedScsiUsb {
    find /proc/scsi/ -path '/proc/scsi/usb-storage*' -type f | xargs grep -l 'Attached: Yes'
}
function scsiDevFromScsiUsb {
    echo $1 | awk -F"[-/]" '{ n=$(NF-1);  print "/dev/sd" substr("abcdefghijklmnopqrstuvwxyz", n+1,
 1) }'
}

if [ "${ACTION}" = "add" ] && [ -f "${DEVICE}" ]; then
    ##
    #   usbcam.
    #
    if [ -f /var/run/console.lock ]; then
        CONSOLEOWNER=`cat /var/run/console.lock`
    elif [ -f /var/lock/console.lock ]; then
        CONSOLEOWNER=`cat /var/lock/console.lock`
    else
        CONSOLEOWNER=
    fi
    for procEntry in $(allAttachedScsiUsb); do
        scsiDev=$(scsiDevFromScsiUsb $procEntry)
        #     usb-storage?
        #      /proc/partitions   
        #+        .
        /sbin/fdisk -l $scsiDev >/dev/null
        ##
        #       , 
        #+ /dev/sd?1. ,     
        #+      .  
        #+    , ..   /dev/sd?1
        #+  .
        #
        if grep -q `basename $scsiDev`1 /proc/partitions; then
            part="$scsiDev""1"
        else
            part=$scsiDev
        fi
        ##
        #    ,  
        #+   .
        #
        if [ ! -z "$CONSOLEOWNER" ]; then
            chown $CONSOLEOWNER:disk $part
        fi
        ##
        #   --   UUID   devlabel.
        #  ,     .
        #
        prodid=`$DEVLABEL printid -d $part`
        if ! grep -q $prodid $DEVLABELCONFIG; then
            #  ,   
            $DEVLABEL add -d $part -s $SYMLINKDEV 2>/dev/null
        fi
        ##
        #    ,   .
        #
        if [ ! -e $MOUNTPOINT ]; then
            mkdir -p $MOUNTPOINT
        fi
        ##
        #       /etc/fstab.
        #
        if ! grep -q "^$SYMLINKDEV" /etc/fstab; then
            #    fstab 
            echo -e \
                "$SYMLINKDEV\t\t$MOUNTPOINT\t\tauto\tnoauto,owner,kudzu 0 0" \
                >> /etc/fstab
        fi
    done
    if [ ! -z "$REMOVER" ]; then
        ##
        #      .
        #
        mkdir -p `dirname $REMOVER`
        ln -s $IAM $REMOVER
    fi
elif [ "${ACTION}" = "remove" ]; then
    ##
    #    --  .
    #
    if grep -q "$MOUNTPOINT" /etc/mtab; then
        # 
        umount -l $MOUNTPOINT
    fi
    ##
    #    /etc/fstab,    .
    #
    if grep -q "^$SYMLINKDEV" /etc/fstab; then
        grep -v "^$SYMLINKDEV" /etc/fstab > /etc/.fstab.new
        mv -f /etc/.fstab.new /etc/fstab
    fi
fi
